#!/usr/bin/perl
#
# asc2pov converts AAIGrid: Arc/Info ASCII Grid DEM into
# povray heightfield tga data
# 
# $Id: asc2pov.pl,v 1.2 2005/05/11 20:08:57 axelm Exp $
# (c) 2005 Alexander Mayrhofer <axelm-asc2pov@nona.net>
# http://nona.net/software/asc2pov/
# see "README" for usage info and "LICENSE" for copying (BSD style)

$line = <>;
$line =~ /^ncols\s+(\d+)$/;
$ncols = $1;
$line = <>;
$line =~ /^nrows\s+(\d+)$/;
$nrows = $1;
$line = <>; $line = <>; $line = <>; # skipping 3 lines

# write header:
binmode(STDOUT);

print pack(C, 0); # identsize
print pack(C, 0); # color map - none
print pack(C, 2); # imagetype (rgb)
print pack(CsC, 0, 0, 0); # color palette related stuff - we have none
print pack(ss, 0, 0); # xstart, ystart
print pack(C, 0); # never found out what this byte is for - probably error?
print pack(vv, $ncols, $nrows); # width, height
print pack(C, 24); # bits per pixel
print pack(C, 32); # image descriptor bits 

# we believe that data starts now - UNSAFE!

while ($line = <>) {
@vals = split(/ /, $line);
$colcount = 0;
foreach $val (@vals) {
   next unless $val =~ /\d+/;
   $val += 32768;
   print pack(C, 0); # fill byte
   print pack(C, $val % 256); # LSB
   print pack(C, int($val/256)); # MSB
   $colcount++;
   }
$rowcount++;
}

print STDERR "rows: $rowcount\n";

